'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _reactDomServer = require('react-dom/server');

var _reactDomServer2 = _interopRequireDefault(_reactDomServer);

var $ = require('jquery');
var dt = require('datatables.net-bs');
var buttons = require('datatables.net-buttons-bs');

require('datatables.net-buttons/js/buttons.colVis.js'); // Column visibility
require('datatables.net-buttons/js/buttons.html5.js'); // HTML 5 file export
require('datatables.net-buttons/js/buttons.flash.js'); // Flash file export
require('datatables.net-buttons/js/buttons.print.js'); // Print view button

var simpleGet = function simpleGet(key) {
  return function (data) {
    return data[key];
  };
};
var keyGetter = function keyGetter(keys) {
  return function (data) {
    return keys.map(function (key) {
      return data[key];
    });
  };
};

var isEmpty = function isEmpty(value) {
  return value == null || value === '';
};

var getCellValue = function getCellValue(_ref, row) {
  var prop = _ref.prop;
  var defaultContent = _ref.defaultContent;
  var render = _ref.render;
  return(
    // Return `defaultContent` if the value is empty.
    !isEmpty(prop) && isEmpty(row[prop]) ? defaultContent :
    // Use the render function for the value.
    render ? render(row[prop], row) :
    // Otherwise just return the value.
    row[prop]
  );
};

var getCellClass = function getCellClass(_ref2, row) {
  var prop = _ref2.prop;
  var className = _ref2.className;
  return !isEmpty(prop) && isEmpty(row[prop]) ? 'empty-cell' : typeof className == 'function' ? className(row[prop], row) : className;
};

var Table = (function (_Component) {
  _inherits(Table, _Component);

  function Table(props) {
    _classCallCheck(this, Table);

    _get(Object.getPrototypeOf(Table.prototype), 'constructor', this).call(this, props);
    console.log('Table constructor', this);
    this._headers = [];

    //  bind event handlers in the constructor so they are only bound once for every instance
  }

  _createClass(Table, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      console.log('Table componentDidMount', this);
      var _props = this.props;
      var columns = _props.columns;
      var dataArray = _props.dataArray;
      var className = _props.className;

      var self = this;

      var table = this.getDTMarkup();
      console.log('ReactDOM', _reactDom2['default']);
      var dtContainer = this.refs.dtContainer;
      _reactDomServer2['default'].renderToStaticMarkup(table, dtContainer);
      console.log('dtContainer', dtContainer);

      var jqueryTable = $('#dt');
      console.log('renderedTable', renderedTable);

      // let jqueryTable = $(table);
      // let tableString = '<table class="';
      // tableString += className;
      // tableString += '"><thead><tr>';
      // columns.forEach(function addHeader(col) {
      //   tableString += ('<th>' + col.title + '</th>');
      // });
      // tableString += '</tr></thead><tbody></tbody></table>';

      // let jqueryTable = $(tableString);
      console.log('jqueryTable', jqueryTable);

      // dtContainer.append(jqueryTable);

      // console.log('dtContainer', dtContainer);

      // let initColumns = columns.map((col, idx) => {
      //   let rCol = {};
      //   rCol['data'] = col.prop;
      //   return rCol;
      // });
      //
      // console.log('dataArray', dataArray);
      // console.log('initColumns', initColumns);

      jqueryTable.DataTable({ // eslint-disable-line new-cap
        // "data": dataArray,
        // "columns": initColumns,
        dom: '<"html5buttons"B>lTfgitp',
        buttons: ['copy', 'csv', 'excel', 'pdf', 'print'],
        "pagingType": 'numbers',
        "bAutoWidth": false,
        "bDestroy": true,
        "fnDrawCallback": function fnDrawCallback() {
          console.log('datatables fnDrawCallback');
          // self.forceUpdate();
        }
      });
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      console.log('Table shouldComponentUpdate', this);
      console.log('nextProps', nextProps);
      console.log('nextState', nextState);

      // check if dataArray changes, if so implement componentDidMount code in componentWillUpdate
      return false;
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      console.log('Table componentWillUnmount', this);
    }
  }, {
    key: 'getDTMarkup',
    value: function getDTMarkup() {
      var _this = this;

      console.log('Table getDTMarkup', this);

      var _props2 = this.props;
      var columns = _props2.columns;
      var keys = _props2.keys;
      var buildRowOptions = _props2.buildRowOptions;
      var sortBy = _props2.sortBy;
      var onSort = _props2.onSort;

      var headers = columns.map(function (col, idx) {

        return _react2['default'].createElement(
          'th',
          {
            ref: function (c) {
              return _this._headers[idx] = c;
            },
            key: idx,
            style: { width: col.width },
            role: 'columnheader',
            scope: 'col' },
          _react2['default'].createElement(
            'span',
            null,
            col.title
          )
        );
      });

      var getKeys = Array.isArray(keys) ? keyGetter(keys) : simpleGet(keys);
      var rows = this.props.dataArray.map(function (row) {
        return _react2['default'].createElement(
          'tr',
          _extends({ key: getKeys(row) }, buildRowOptions(row)),
          columns.map(function (col, i) {
            return _react2['default'].createElement(
              'td',
              { key: i, className: getCellClass(col, row) },
              getCellValue(col, row)
            );
          })
        );
      });

      return _react2['default'].createElement(
        'table',
        _extends({ id: 'dt' }, this.props),
        _react2['default'].createElement(
          'thead',
          null,
          _react2['default'].createElement(
            'tr',
            null,
            headers
          )
        ),
        _react2['default'].createElement(
          'tbody',
          null,
          rows.length ? rows : _react2['default'].createElement(
            'tr',
            null,
            _react2['default'].createElement(
              'td',
              { colSpan: columns.length, className: 'text-center' },
              'No data'
            )
          )
        )
      );
    }
  }, {
    key: 'render',
    value: function render() {
      console.log('Table render', this);
      return _react2['default'].createElement(
        'div',
        null,
        _react2['default'].createElement('div', { ref: 'dtContainer' }),
        _react2['default'].createElement('div', { ref: 'dtContainer2' })
      );
    }
  }], [{
    key: 'defaultProps',
    value: {
      buildRowOptions: function buildRowOptions() {
        return {};
      },
      sortBy: {}
    },
    enumerable: true
  }, {
    key: 'propTypes',
    value: {
      keys: _react.PropTypes.oneOfType([_react.PropTypes.arrayOf(_react.PropTypes.string), _react.PropTypes.string]).isRequired,

      columns: _react.PropTypes.arrayOf(_react.PropTypes.shape({
        title: _react.PropTypes.string.isRequired,
        prop: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.number]),
        render: _react.PropTypes.func,
        sortable: _react.PropTypes.bool,
        defaultContent: _react.PropTypes.string,
        width: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.number]),
        className: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.func])
      })).isRequired,

      dataArray: _react.PropTypes.arrayOf(_react.PropTypes.oneOfType([_react.PropTypes.array, _react.PropTypes.object])).isRequired,

      buildRowOptions: _react.PropTypes.func,

      sortBy: _react.PropTypes.shape({
        prop: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.number]),
        order: _react.PropTypes.oneOf(['ascending', 'descending'])
      }),

      onSort: _react.PropTypes.func
    },
    enumerable: true
  }]);

  return Table;
})(_react.Component);

exports['default'] = Table;
module.exports = exports['default'];